/**
 * @file Board.cpp
 * @brief Board osztly nem inline fggvnyei
 */

#include "Board.h"
#include <stdexcept>

// j alakzat felraksa
void Board::put(Shape *sp) {
	// Ellenrizzk, hogy befr-e
    if (n >= MAXN) 
		throw std::out_of_range("Board: full!");
    // Ha igen, eltesszk a pointert
	shapes[n++] = sp;
}

// Mindenkit rajzol
void Board::draw() {
    for (unsigned int i = 0; i < n; i++)
        shapes[i]->draw();
}
 
// Alakzatok trlse
// Fontos: a delete opertort egyenknt hvjuk a tmb
// elemeire. Csak ez a megolds hasznlhat.
void Board::clear() {
	for (unsigned int i = 0; i < n; i++)
		delete shapes[i];
	n = 0;
}

// tmsoljuk (klnozssal az alakzatokat egy msik Boardrl.
Board& Board::operator+=(const Board& b) {
	if(n + b.n >= MAXN)
		throw std::out_of_range("Board: too much!");
	for (unsigned int i = n; i < n + b.n; ++i)
		shapes[i] = b.shapes[i-n]->clone();
	n += b.n;

	return *this;
}