/**
 * @file Circle.h
 * @brief Circle osztly interfsze
 */
#ifndef CIRCLE_H
#define CIRCLE_H

#include "Shape.h"

class Circle : public Shape {
    int r;		// sugr
public:
    // Konstruktor
    Circle(const Point& p0, int r, const Color& c)
		: Shape(p0, c), r(r) {} 

	// Sugr lekrdezse
	int getR() const { return r; }

    // Rajzols
    void draw();
	
	// Klnozs
	Shape* clone() const {
		return new Circle(*this);
	}
};

// Inserter
std::ostream& operator<<(std::ostream& os, const Circle& c);

#endif