/**
 * @file Polygon.cpp
 * @brief Polygon nem inline fggvnyei
 */

#include "Polygon.h"
#include <stdexcept>

// Pont lekrse
Point Polygon::getP(unsigned int i) const {
    if (i >= np) 
		throw std::out_of_range("Polygon: no such point exists!");
    if (i == 0) 
		return p0;
	// A pont abszolt koordintit adja vissza, de relatvat trolunk. 
	// (Itt ideiglenes eredmnyt adunk vissza, ezrt nem referencit hasznlunk.)
    return points[i-1] + p0;						
}

// j pont felvtele
void Polygon::add(const Point& p) {
	// j pont trol s msols
    Point *temp_points = new Point[np];			
    for (unsigned int i = 0; i < np-1; ++i)
        temp_points[i] = points[i];
    delete[] points;			
	// Pointer tvtele
    points = temp_points;							
    points[np-1] = p - p0;							
    ++np;							
}

// Rajzols
void Polygon::draw() {
    std::cout << "Draw: " << *this << std::endl;
}
 
// Inserter
std::ostream& operator<<(std::ostream& os, const Polygon& p) {
	// Shape&-ra castolva a Shape-hez tartoz insertert hvjuk
    os << "Polygon " << (Shape&)p << ", np: " << p.getNp();
    for (unsigned int i = 1; i < p.getNp(); ++i)
       os << ", p" << i << ": " << p.getP(i);
    return os;
}