/**
 *  \file Section.h
 *  @brief Section (szakasz) osztly interfsze
 */
#ifndef SECTION_H
#define SECTION_H

#include "Shape.h"

// Section
class Section : public Shape {
    Point d;    // vgpont vektora a kezdpontbl
public:
	// Konstruktor 2 Pointbl
	Section(const Point& p0, const Point& p1, const Color& c)
                     : Shape(p0, c), d(p1-p0) { }

    // Konstruktor 1 pontbl s kt tvolsgbl
	Section(const Point& p0, int xl, int yl, const Color& c)
                     : Shape(p0, c), d(xl, yl) { }

	// Vektor lekrse
	const Point& getD() const { return d; }

    // Klnozs
    Shape* clone() const {
		return new Section(*this);
	}
    
    // Rajzols
    void draw();	    
};

// Inserter
std::ostream& operator<<(std::ostream& os, const Section& s);

#endif
