/**
 * @file main.cpp
 * @brief Program a Board heterogn kollekci tesztelshez
 */

#include <iostream>
#include "Board.h"
#include "Section.h"
#include "Circle.h"
#include "Polygon.h"

using namespace std;

int main(int argc, char** argv) {

	try {
		// Board ltrehozsa
        Board board;
		
		// Rtesznk pr alakzatot
        board.put(new Section(Point(20,40), 100, 0, WHITE));
		board.put(new Circle(Point(120,140), 50, BLUE));
		board.put(new Shape(Point(320,80), GREEN));
		
		// Poligont hozunk ltre, rtesszk a tblra
        Polygon* poly = new Polygon(Point(120,140), GREEN);
        poly->add(Point(120,200));
        poly->add(Point(250,200));
        board.put(poly);
        
		// Rajzols
		cout << "Board drawing:" << endl;
        board.draw();
        
		// Trls
		cout << "Board clearing:" << endl;
        board.clear();
        
		// j alakzatok
		board.put(new Circle(Point(10,20), 50, RED));
        
		// Draw the board again
        cout << "Board drawing:" << endl;
	    board.draw();
		
		// Msols
		Board other = board;
		other += board;

		cout << "Other board: " << endl;
		other.draw();
		
    } catch (exception& e) {
        cerr << "Exception: " << e.what() << endl;
    }
    return 0;
}